#!/usr/bin/env python
# vi: tabstop=4:

import time, sys, os
from teelog import TeeLog

try:
	tee=TeeLog(realout=sys.stdout, logname="ALTANE")
	sys.stdout=tee
except Exception, e:
	print "Exception while teeing log."

from modulepath import module_path

print "Current directory: ", os.getcwd()
print "Script path: ", module_path()


from Queue import Queue
import getopt

from serialwrapper import SerialWrapper, SerialWrapper_pySerial
from altanegui import *
from serialgui import *
from altaneclient import *
from configmanager import *

# Parse config
defaultconfig = {
	'enablelog':True,
	'compresslog':True,
}

cm = ConfigManager("ALTANE", defaultconfig)

# Set up logging
if cm.config['enablelog']:
	try:
		if not cm.appdir:
			raise
		logdir = os.path.join(cm.appdir,"logs")
		if not os.path.exists(logdir):
			os.makedirs(logdir)
		tee.openlog(logdir)
	except Exception, e:
		print "Error opening log..."
		tee.openlog(False)
else:
	tee.openlog(False)

# Parse command line args
print "executable: ", sys.executable
print "argv: ", sys.argv

args = sys.argv[1:]
optlist, args = getopt.getopt(args, '', ['fixport='])

for i in optlist:
	if i[0]=='--fixport':
		import regfix
		import traceback
		try:
			ret = regfix.dofix(i[1])
		except Exception, e:
			raise e

		sys.exit(ret)

port, lib = getPortFromPrefix("LT")


if not port:
	print "Serial port not found on first try. Showing wait window."

	options={'manualselect':False}
	root = Tk()
	serialwaitWin=SerialWait(master=root, options=options)
	serialwaitWin.mainloop()
	root.destroy()

	if not options['manualselect']:
		try:
			lib = serialwaitWin.options['lib']
			port = serialwaitWin.options['port']
		except KeyError:
			print "User cancelled the wait window."
			sys.exit(0)


#time.sleep(10)
#sys.exit(1)

if not port:
	root = Tk()
	serialWin=SerialSelect(master=root)
	serialWin.mainloop()

	try:
		lib = serialWin.options['lib']
		port = serialWin.options['port']
	except KeyError:
		print "Nothing selected."
		sys.exit(0)

# Create queue objects for sending messages between the threads.
q_u2f = Queue()
q_f2u = Queue()

try:
	print "Lib: " + str(lib) + " Port:" + str(port)
	ct = ClientThread()

	ct.lib = lib
	ct.port = port
	ct.q_u2f = q_u2f
	ct.q_f2u = q_f2u

	# setting the worker thread as a daemon allows the user to ctrl-c to kill the process
	ct.daemon = True
	ct.start()

	aw = AppWindow(options={'q_u2f':q_u2f,'q_f2u':q_f2u})
	aw.mainloop()
	aw.master.destroy()
	#sys.exit()
	print "OH"
	q_u2f.put(("resetdie",None))
	time.sleep(.4)
	print "NO"

except KeyError:
	print "Nothing selected."
except KeyboardInterrupt:
	print "User pressed ctrl-c."
	q_u2f.put(("resetdie",None))
	time.sleep(.4)

print "Bye!"
